
def cifar100_loss(output, sum=True, train=False, mu=10.0,
                  a=True, b=True, c=True, d=True,
                  names=None, targets=False, scale="none",
                  max=False, return_arg_max=False):

    # MAIN CLASSES
    APPLE = output[:, 0]
    AQUARIUM_FISH = output[:, 1]
    BABY = output[:, 2]
    BEAR = output[:, 3]
    BEAVER = output[:, 4]
    BED = output[:, 5]
    BEE = output[:, 6]
    BEETLE = output[:, 7]
    BICYCLE = output[:, 8]
    BOTTLE = output[:, 9]
    BOWL = output[:, 10]
    BOY = output[:, 11]
    BRIDGE = output[:, 12]
    BUS = output[:, 13]
    BUTTERFLY = output[:, 14]
    CAMEL = output[:, 15]
    CAN = output[:, 16]
    CASTLE = output[:, 17]
    CATERPILLAR = output[:, 18]
    CATTLE = output[:, 19]
    CHAIR = output[:, 20]
    CHIMPANZEE = output[:, 21]
    CLOCK = output[:, 22]
    CLOUD = output[:, 23]
    COCKROACH = output[:, 24]
    COUCH = output[:, 25]
    CRAB = output[:, 26]
    CROCODILE = output[:, 27]
    CUP = output[:, 28]
    DINOSAUR = output[:, 29]
    DOLPHIN = output[:, 30]
    ELEPHANT = output[:, 31]
    FLATFISH = output[:, 32]
    FOREST = output[:, 33]
    FOX = output[:, 34]
    GIRL = output[:, 35]
    HAMSTER = output[:, 36]
    HOUSE = output[:, 37]
    KANGAROO = output[:, 38]
    KEYBOARD = output[:, 39]
    LAMP = output[:, 40]
    LAWN_MOWER = output[:, 41]
    LEOPARD = output[:, 42]
    LION = output[:, 43]
    LIZARD = output[:, 44]
    LOBSTER = output[:, 45]
    MAN = output[:, 46]
    MAPLE_TREE = output[:, 47]
    MOTORCYCLE = output[:, 48]
    MOUNTAIN = output[:, 49]
    MOUSE = output[:, 50]
    MUSHROOM = output[:, 51]
    OAK_TREE = output[:, 52]
    ORANGE = output[:, 53]
    ORCHID = output[:, 54]
    OTTER = output[:, 55]
    PALM_TREE = output[:, 56]
    PEAR = output[:, 57]
    PICKUP_TRUCK = output[:, 58]
    PINE_TREE = output[:, 59]
    PLAIN = output[:, 60]
    PLATE = output[:, 61]
    POPPY = output[:, 62]
    PORCUPINE = output[:, 63]
    POSSUM = output[:, 64]
    RABBIT = output[:, 65]
    RACCOON = output[:, 66]
    RAY = output[:, 67]
    ROAD = output[:, 68]
    ROCKET = output[:, 69]
    ROSE = output[:, 70]
    SEA = output[:, 71]
    SEAL = output[:, 72]
    SHARK = output[:, 73]
    SHREW = output[:, 74]
    SKUNK = output[:, 75]
    SKYSCRAPER = output[:, 76]
    SNAIL = output[:, 77]
    SNAKE = output[:, 78]
    SPIDER = output[:, 79]
    SQUIRREL = output[:, 80]
    STREETCAR = output[:, 81]
    SUNFLOWER = output[:, 82]
    SWEET_PEPPER = output[:, 83]
    TABLE = output[:, 84]
    TANK = output[:, 85]
    TELEPHONE = output[:, 86]
    TELEVISION = output[:, 87]
    TIGER = output[:, 88]
    TRACTOR = output[:, 89]
    TRAIN = output[:, 90]
    TROUT = output[:, 91]
    TULIP = output[:, 92]
    TURTLE = output[:, 93]
    WARDROBE = output[:, 94]
    WHALE = output[:, 95]
    WILLOW_TREE = output[:, 96]
    WOLF = output[:, 97]
    WOMAN = output[:, 98]
    WORM = output[:, 99]

    # SUPER CLASSES
    AQUATIC_MAMMALS = output[:, 100]
    FISH = output[:, 101]
    FLOWERS = output[:, 102]
    FOOD_CONTAINERS = output[:, 103]
    FRUIT_AND_VEGETABLES = output[:, 104]
    HOUSEHOLD_ELECTRICAL_DEVICES = output[:, 105]
    HOUSEHOLD_FURNITURE = output[:, 106]
    INSECTS = output[:, 107]
    LARGE_CARNIVORES = output[:, 108]
    LARGE_MAN_MADE_OUTDOOR_THINGS = output[:, 109]
    LARGE_NATURAL_OUTDOOR_SCENES = output[:, 110]
    LARGE_OMNIVORES_AND_HERBIVORES = output[:, 111]
    MEDIUM_MAMMALS = output[:, 112]
    NON_INSECT_INVERTEBRATES = output[:, 113]
    PEOPLE = output[:, 114]
    REPTILES = output[:, 115]
    SMALL_MAMMALS = output[:, 116]
    TREES = output[:, 117]
    VEHICLES_1 = output[:, 118]
    VEHICLES_2 = output[:, 119]

    loss_fol_product_tnorm = [

        # ∀X AQUATIC_MAMMALS(X)⇒BEAVER(X)∨DOLPHIN(X)∨OTTER(X)∨SEAL(X)∨WHALE(X)
        (AQUATIC_MAMMALS * ((1 - BEAVER) * (1 - DOLPHIN) * (1 - OTTER) * (1 - SEAL) * (1 - WHALE))),
        # ∀X BEAVER(X)⇒AQUATIC_MAMMALS(X)
        (BEAVER * (1 - AQUATIC_MAMMALS)),
        # ∀X DOLPHIN(X)⇒AQUATIC_MAMMALS(X)
        (DOLPHIN * (1 - AQUATIC_MAMMALS)),
        # ∀X OTTER(X)⇒AQUATIC_MAMMALS(X)
        (OTTER * (1 - AQUATIC_MAMMALS)),
        # ∀X SEAL(X)⇒AQUATIC_MAMMALS(X)
        (SEAL * (1 - AQUATIC_MAMMALS)),
        # ∀X WHALE(X)⇒AQUATIC_MAMMALS(X)
        (WHALE * (1 - AQUATIC_MAMMALS)),

        # ∀X FISH(X)⇒AQUARIUM FISH(X)∨FLATFISH(X)∨RAY(X)∨SHARK(X)∨TROUT(X)
        (FISH * (1 - AQUARIUM_FISH) * (1 - FLATFISH) * (1 - RAY) * (1 - SHARK) * (1 - TROUT)),
        # ∀X AQUARIUM_FISH(X)⇒FISH(X)
        (AQUARIUM_FISH * (1 - FISH)),
        # ∀X FLATFISH(X)⇒FISH(X)
        (FLATFISH * (1 - FISH)),
        # ∀X RAY(X)⇒FISH(X)
        (RAY * (1 - FISH)),
        # ∀X SHARK(X)⇒FISH(X)
        (SHARK * (1 - FISH)),
        # ∀X TROUT(X)⇒FISH(X)
        (TROUT * (1 - FISH)),

        # ∀X FLOWERS(X)⇒ORCHID(X)∨POPPY(X)∨ROSE(X)∨SUNFLOWER(X)∨TULIP(X)
        (FLOWERS * (1 - ORCHID) * (1 - POPPY) * (1 - ROSE) * (1 - SUNFLOWER) * (1 - TULIP)),
        # ∀X ORCHID(X)⇒FLOWERS(X)
        (ORCHID * (1 - FLOWERS)),
        # ∀X POPPY(X)⇒FLOWERS(X)
        (POPPY * (1 - FLOWERS)),
        # ∀X ROSE(X)⇒FLOWERS(X)
        (ROSE * (1 - FLOWERS)),
        # ∀X SUNFLOWER(X)⇒FLOWERS(X)
        (SUNFLOWER * (1 - FLOWERS)),
        # ∀X TULIP(X)⇒FLOWERS(X)
        (TULIP * (1 - FLOWERS)),

        # ∀X FOOD_CONTAINERS(X)⇒BOTTLE(X)∨BOWL(X)∨CAN(X)∨CUP(X)∨PLATE(X)
        (FOOD_CONTAINERS * (1 - BOTTLE) * (1 - BOWL) * (1 - CAN) * (1 - CUP) * (1 - PLATE)),
        # ∀X BOTTLE(X)⇒FOOD_CONTAINERS(X)
        (BOTTLE * (1 - FOOD_CONTAINERS)),
        # ∀X BOWL(X)⇒FOOD_CONTAINERS(X)
        (BOWL * (1 - FOOD_CONTAINERS)),
        # ∀X CAN(X)⇒FOOD_CONTAINERS(X)
        (CAN * (1 - FOOD_CONTAINERS)),
        # ∀X CUP(X)⇒FOOD_CONTAINERS(X)
        (CUP * (1 - FOOD_CONTAINERS)),
        # ∀X PLATE(X)⇒FOOD_CONTAINERS(X)
        (PLATE * (1 - FOOD_CONTAINERS)),

        # ∀X FRUIT_AND_VEGETABLES(X)⇒APPLE(X)∨MUSHROOM(X)∨ORANGE(X)∨PEAR(X)∨SWEET_PEPPER(X)
        (FRUIT_AND_VEGETABLES * (1 - APPLE) * (1 - MUSHROOM) * (1 - ORANGE) * (1 - PEAR) * (1 - SWEET_PEPPER)),
        # ∀X APPLE(X)⇒FRUIT_AND_VEGETABLES(X)
        (APPLE * (1 - FRUIT_AND_VEGETABLES)),
        # ∀X MUSHROOM(X)⇒FRUIT_AND_VEGETABLES(X)
        (MUSHROOM * (1 - FRUIT_AND_VEGETABLES)),
        # ∀X ORANGE(X)⇒FRUIT_AND_VEGETABLES(X)
        (ORANGE * (1 - FRUIT_AND_VEGETABLES)),
        # ∀X PEAR(X)⇒FRUIT_AND_VEGETABLES(X)
        (PEAR * (1 - FRUIT_AND_VEGETABLES)),
        # ∀X SWEET_PEPPER(X)⇒FRUIT_AND_VEGETABLES(X)
        (SWEET_PEPPER * (1 - FRUIT_AND_VEGETABLES)),

        # ∀X HOUSEHOLD_ELECTRICAL_DEVICES(X)⇒CLOCK(X)∨KEYBOARD(X)∨LAMP(X)∨TELEPHONE(X)∨TELEVISION(X)
        (HOUSEHOLD_ELECTRICAL_DEVICES * (1 - CLOCK) * (1 - KEYBOARD) * (1 - LAMP) * (1 - TELEPHONE) * (1 - TELEVISION)),
        # ∀X CLOCK(X)⇒HOUSEHOLD_ELECTRICAL_DEVICES(X)
        (CLOCK * (1 - HOUSEHOLD_ELECTRICAL_DEVICES)),
        # ∀X KEYBOARD(X)⇒HOUSEHOLD_ELECTRICAL_DEVICES(X)
        (KEYBOARD * (1 - HOUSEHOLD_ELECTRICAL_DEVICES)),
        # ∀X LAMP(X)⇒HOUSEHOLD_ELECTRICAL_DEVICES(X)
        (LAMP * (1 - HOUSEHOLD_ELECTRICAL_DEVICES)),
        # ∀X TELEPHONE(X)⇒HOUSEHOLD_ELECTRICAL_DEVICES(X)
        (TELEPHONE * (1 - HOUSEHOLD_ELECTRICAL_DEVICES)),
        # ∀X TELEVISION(X)⇒HOUSEHOLD_ELECTRICAL_DEVICES(X)
        (TELEVISION * (1 - HOUSEHOLD_ELECTRICAL_DEVICES)),

        # ∀X HOUSEHOLD_FURNITURE(X)⇒BED(X)∨CHAIR(X)∨COUCH(X)∨TABLE(X)∨WARDROBE(X)
        (HOUSEHOLD_FURNITURE * (1 - BED) * (1 - CHAIR) * (1 - COUCH) * (1 - TABLE) * (1 - WARDROBE)),
        # ∀X BED(X)⇒HOUSEHOLD_FURNITURE(X)
        (BED * (1 - HOUSEHOLD_FURNITURE)),
        # ∀X CHAIR(X)⇒HOUSEHOLD_FURNITURE(X)
        (CHAIR * (1 - HOUSEHOLD_FURNITURE)),
        # ∀X COUCH(X)⇒HOUSEHOLD_FURNITURE(X)
        (COUCH * (1 - HOUSEHOLD_FURNITURE)),
        # ∀X TABLE(X)⇒HOUSEHOLD_FURNITURE(X)
        (TABLE * (1 - HOUSEHOLD_FURNITURE)),
        # ∀X WARDROBE(X)⇒HOUSEHOLD_FURNITURE(X)
        (WARDROBE * (1 - HOUSEHOLD_FURNITURE)),

        # ∀X INSECTS(X)⇒BEE(X)∨BEETLE(X)∨BUTTERFLY(X)∨CATERPILLAR(X)∨COCKROACH(X)
        (INSECTS * (1 - BEE) * (1 - BEETLE) * (1 - BUTTERFLY) * (1 - CATERPILLAR) * (1 - COCKROACH)),
        # ∀X BEE(X)⇒INSECTS(X)
        (BEE * (1 - INSECTS)),
        # ∀X BEETLE(X)⇒INSECTS(X)
        (BEETLE * (1 - INSECTS)),
        # ∀X BUTTERFLY(X)⇒INSECTS(X)
        (BUTTERFLY * (1 - INSECTS)),
        # ∀X CATERPILLAR(X)⇒INSECTS(X)
        (CATERPILLAR * (1 - INSECTS)),
        # ∀X COCKROACH(X)⇒INSECTS(X)
        (COCKROACH * (1 - INSECTS)),

        # ∀X LARGE_CARNIVORES(X)⇒BEAR(X)∨LEOPARD(X)∨LION(X)∨TIGER(X)∨WOLF(X)
        (LARGE_CARNIVORES * (1 - BEAR) * (1 - LEOPARD) * (1 - LION) * (1 - TIGER) * (1 - WOLF)),
        # ∀X BEAR(X)⇒LARGE_CARNIVORES(X)
        (BEAR * (1 - LARGE_CARNIVORES)),
        # ∀X LEOPARD(X)⇒LARGE_CARNIVORES(X)
        (LEOPARD * (1 - LARGE_CARNIVORES)),
        # ∀X LION(X)⇒LARGE_CARNIVORES(X)
        (LION * (1 - LARGE_CARNIVORES)),
        # ∀X TIGER(X)⇒LARGE_CARNIVORES(X)
        (TIGER * (1 - LARGE_CARNIVORES)),
        # ∀X WOLF(X)⇒LARGE_CARNIVORES(X)
        (WOLF * (1 - LARGE_CARNIVORES)),

        # ∀XLARGE_MAN - MADE_OUTDOOR_THINGS(X)⇒BRIDGE(X)∨CASTLE(X)∨HOUSE(X)∨ROAD(X)∨SKYSCRAPER(X)
        (LARGE_MAN_MADE_OUTDOOR_THINGS * (1 - BRIDGE) * (1 - CASTLE) * (1 - HOUSE) * (1 - ROAD) * (1 - SKYSCRAPER)),
        # ∀XBRIDGE(X)⇒LARGE_MAN - MADE_OUTDOOR_THINGS(X)
        (BRIDGE * (1 - LARGE_MAN_MADE_OUTDOOR_THINGS)),
        # ∀XCASTLE(X)⇒LARGE_MAN - MADE_OUTDOOR_THINGS(X)
        (CASTLE * (1 - LARGE_MAN_MADE_OUTDOOR_THINGS)),
        # ∀XHOUSE(X)⇒LARGE_MAN - MADE_OUTDOOR_THINGS(X)
        (HOUSE * (1 - LARGE_MAN_MADE_OUTDOOR_THINGS)),
        # ∀XROAD(X)⇒LARGE_MAN - MADE_OUTDOOR_THINGS(X)
        (ROAD * (1 - LARGE_MAN_MADE_OUTDOOR_THINGS)),
        # ∀XSKYSCRAPER(X)⇒LARGE_MAN - MADE_OUTDOOR_THINGS(X)
        (SKYSCRAPER * (1 - LARGE_MAN_MADE_OUTDOOR_THINGS)),

        # ∀XLARGE_NATURAL_OUTDOOR_SCENES(X)⇒CLOUD(X)∨FOREST(X)∨MOUNTAIN(X)∨PLAIN(X)∨SEA(X)
        (LARGE_NATURAL_OUTDOOR_SCENES * (1 - CLOUD) * (1 - FOREST) * (1 - MOUNTAIN) * (1 - PLAIN) * (1 - SEA)),
        # ∀XCLOUD(X)⇒LARGE_NATURAL_OUTDOOR_SCENES(X)
        (CLOUD * (1 - LARGE_NATURAL_OUTDOOR_SCENES)),
        # ∀XFOREST(X)⇒LARGE_NATURAL_OUTDOOR_SCENES(X)
        (FOREST * (1 - LARGE_NATURAL_OUTDOOR_SCENES)),
        # ∀XMOUNTAIN(X)⇒LARGE_NATURAL_OUTDOOR_SCENES(X)
        (MOUNTAIN * (1 - LARGE_NATURAL_OUTDOOR_SCENES)),
        # ∀XPLAIN(X)⇒LARGE_NATURAL_OUTDOOR_SCENES(X)
        (PLAIN * (1 - LARGE_NATURAL_OUTDOOR_SCENES)),
        # ∀XSEA(X)⇒LARGE_NATURAL_OUTDOOR_SCENES(X)
        (SEA * (1 - LARGE_NATURAL_OUTDOOR_SCENES)),

        # ∀XLARGE_OMNIVORES_AND_HERBIVORES(X)⇒CAMEL(X)∨CATTLE(X)∨CHIMPANZEE(X)∨ELEPHANT(X)∨KANGAROO(X)
        (LARGE_OMNIVORES_AND_HERBIVORES * (1 - CAMEL) * (1 - CATTLE) * (1 - CHIMPANZEE) * (1 - ELEPHANT) * (
                1 - KANGAROO)),
        # ∀XCAMEL(X)⇒LARGE_OMNIVORES_AND_HERBIVORES(X)
        (CAMEL * (1 - LARGE_OMNIVORES_AND_HERBIVORES)),
        # ∀XCATTLE(X)⇒LARGE_OMNIVORES_AND_HERBIVORES(X)
        (CATTLE * (1 - LARGE_OMNIVORES_AND_HERBIVORES)),
        # ∀XCHIMPANZEE(X)⇒LARGE_OMNIVORES_AND_HERBIVORES(X)
        (CHIMPANZEE * (1 - LARGE_OMNIVORES_AND_HERBIVORES)),
        # ∀XELEPHANT(X)⇒LARGE_OMNIVORES_AND_HERBIVORES(X)
        (ELEPHANT * (1 - LARGE_OMNIVORES_AND_HERBIVORES)),
        # ∀XKANGAROO(X)⇒LARGE_OMNIVORES_AND_HERBIVORES(X)
        (KANGAROO * (1 - LARGE_OMNIVORES_AND_HERBIVORES)),

        # ∀XMEDIUM_MAMMALS(X)⇒FOX(X)∨PORCUPINE(X)∨POSSUM(X)∨RACCOON(X)∨SKUNK(X)
        (MEDIUM_MAMMALS * (1 - FOX) * (1 - PORCUPINE) * (1 - POSSUM) * (1 - RACCOON) * (1 - SKUNK)),
        # ∀XFOX(X)⇒MEDIUM_MAMMALS(X)
        (FOX * (1 - MEDIUM_MAMMALS)),
        # ∀XPORCUPINE(X)⇒MEDIUM_MAMMALS(X)
        (PORCUPINE * (1 - MEDIUM_MAMMALS)),
        # ∀XPOSSUM(X)⇒MEDIUM_MAMMALS(X)
        (POSSUM * (1 - MEDIUM_MAMMALS)),
        # ∀XRACCOON(X)⇒MEDIUM_MAMMALS(X)
        (RACCOON * (1 - MEDIUM_MAMMALS)),
        # ∀XSKUNK(X)⇒MEDIUM_MAMMALS(X)
        (SKUNK * (1 - MEDIUM_MAMMALS)),

        # ∀X NON_INSECT_INVERTEBRATES(X)⇒CRAB(X)∨LOBSTER(X)∨SNAIL(X)∨SPIDER(X)∨WORM(X)
        (NON_INSECT_INVERTEBRATES * (1 - CRAB) * (1 - LOBSTER) * (1 - SNAIL) * (1 - SPIDER) * (1 - WORM)),
        # ∀XCRAB(X)⇒NON - INSECT_INVERTEBRATES(X)
        (CRAB * (1 - NON_INSECT_INVERTEBRATES)),
        # ∀XLOBSTER(X)⇒NON - INSECT_INVERTEBRATES(X)
        (LOBSTER * (1 - NON_INSECT_INVERTEBRATES)),
        # ∀XSNAIL(X)⇒NON - INSECT_INVERTEBRATES(X)
        (SNAIL * (1 - NON_INSECT_INVERTEBRATES)),
        # ∀XSPIDER(X)⇒NON - INSECT_INVERTEBRATES(X)
        (SPIDER * (1 - NON_INSECT_INVERTEBRATES)),
        # ∀XWORM(X)⇒NON - INSECT_INVERTEBRATES(X)
        (WORM * (1 - NON_INSECT_INVERTEBRATES)),

        # ∀X PEOPLE(X)⇒BABY(X)∨MAN(X)∨WOMAN(X)∨BOY(X)∨GIRL(X)
        (PEOPLE * (1 - BABY) * (1 - MAN) * (1 - WOMAN) * (1 - BOY) * (1 - GIRL)),
        # ∀XBABY(X)⇒PEOPLE(X)
        (BABY * (1 - PEOPLE)),
        # ∀XBOY(X)⇒PEOPLE(X)
        (BOY * (1 - PEOPLE)),
        # ∀XGIRL(X)⇒PEOPLE(X)
        (GIRL * (1 - PEOPLE)),
        # ∀XMAN(X)⇒PEOPLE(X)
        (MAN * (1 - PEOPLE)),
        # ∀XWOMAN(X)⇒PEOPLE(X)
        (WOMAN * (1 - PEOPLE)),

        # ∀XREPTILES(X)⇒CROCODILE(X)∨DINOSAUR(X)∨LIZARD(X)∨SNAKE(X)∨TURTLE(X)
        (REPTILES * (1 - CROCODILE) * (1 - DINOSAUR) * (1 - LIZARD) * (1 - SNAKE) * (1 - TURTLE)),
        # ∀XCROCODILE(X)⇒REPTILES(X)
        (CROCODILE * (1 - REPTILES)),
        # ∀XDINOSAUR(X)⇒REPTILES(X)
        (DINOSAUR * (1 - REPTILES)),
        # ∀XLIZARD(X)⇒REPTILES(X)
        (LIZARD * (1 - REPTILES)),
        # ∀XSNAKE(X)⇒REPTILES(X)
        (SNAKE * (1 - REPTILES)),
        # ∀XTURTLE(X)⇒REPTILES(X)
        (TURTLE * (1 - REPTILES)),

        # ∀XSMALL_MAMMALS(X)⇒HAMSTER(X)∨MOUSE(X)∨RABBIT(X)∨SHREW(X)∨SQUIRREL(X)
        (SMALL_MAMMALS * (1 - HAMSTER) * (1 - MOUSE) * (1 - RABBIT) * (1 - SHREW) * (1 - SQUIRREL)),
        # ∀XHAMSTER(X)⇒SMALL_MAMMALS(X)
        (HAMSTER * (1 - SMALL_MAMMALS)),
        # ∀XMOUSE(X)⇒SMALL_MAMMALS(X)
        (MOUSE * (1 - SMALL_MAMMALS)),
        # ∀XRABBIT(X)⇒SMALL_MAMMALS(X)
        (RABBIT * (1 - SMALL_MAMMALS)),
        # ∀XSHREW(X)⇒SMALL_MAMMALS(X)
        (SHREW * (1 - SMALL_MAMMALS)),
        # ∀XSQUIRREL(X)⇒SMALL_MAMMALS(X)
        (SQUIRREL * (1 - SMALL_MAMMALS)),

        # ∀XTREES(X)⇒MAPLE_TREE(X)∨OAK_TREE(X)∨PALM_TREE(X)∨PINE_TREE(X)∨WILLOW_TREE(X)
        (TREES * (1 - MAPLE_TREE) * (1 - OAK_TREE) * (1 - PALM_TREE) * (1 - PINE_TREE) * (1 - WILLOW_TREE)),
        # ∀XMAPLE_TREE(X)⇒TREES(X)
        (MAPLE_TREE * (1 - TREES)),
        # ∀XOAK_TREE(X)⇒TREES(X)
        (OAK_TREE * (1 - TREES)),
        # ∀XPALM_TREE(X)⇒TREES(X)
        (PALM_TREE * (1 - TREES)),
        # ∀XPINE_TREE(X)⇒TREES(X)
        (PINE_TREE * (1 - TREES)),
        # ∀XWILLOW_TREE(X)⇒TREE(X
        (WILLOW_TREE * (1 - TREES)),

        # ∀X VEHICLES_1(X)⇒BIKE(X)∨BUS(X)∨MOTORBIKE(X)∨PICKUP_TRUCK(X)∨TRAIN(X)
        (VEHICLES_1 * (1 - BICYCLE) * (1 - BUS) * (1 - MOTORCYCLE) * (1 - PICKUP_TRUCK) * (1 - TRAIN)),
        # ∀XBIKE(X)⇒VEHICLE1(X)
        (BICYCLE * (1 - VEHICLES_1)),
        # ∀XBUS(X)⇒VEHICLE1(X)
        (BUS * (1 - VEHICLES_1)),
        # ∀XMOTORBIKE(X)⇒VEHICLE1(X)
        (MOTORCYCLE * (1 - VEHICLES_1)),
        # ∀XPICKUP(X)⇒VEHICLES_11(X)
        (PICKUP_TRUCK * (1 - VEHICLES_1)),
        # ∀XTRAIN(X)⇒VEHICLES1(X
        (TRAIN * (1 - VEHICLES_1)),

        # ∀XVEHICLES2(X)⇒LAWNMOWER(X)∨ROCKET(X)∨STREETCAR(X)∨TANK(X)∨TRACTOR(X)
        (VEHICLES_2 * (1 - LAWN_MOWER) * (1 - ROCKET) * (1 - STREETCAR) * (1 - TANK) * (1 - TRACTOR)),
        # ∀XLAWNMOWER(X)⇒VEHICLES2(X)
        (LAWN_MOWER * (1 - VEHICLES_2)),
        # ∀XROCKET(X)⇒VEHICLES2(X)
        (ROCKET * (1 - VEHICLES_2)),
        # ∀XSTREETCAR(X)⇒VEHICLES2(X)
        (STREETCAR * (1 - VEHICLES_2)),
        # ∀XTANK(X)⇒VEHICLES2(X)
        (TANK * (1 - VEHICLES_2)),
        # ∀XTRACTOR(X)⇒VEHICLES2(X)
        (TRACTOR * (1 - VEHICLES_2)),
    ]
    # loss_fol_product_tnorm.extend([
    #     # OR ON THE MAIN CLASSES
    #     mu * ((1 - APPLE) * (1 - AQUARIUM_FISH) * (1 - BABY) * (1 - BEAR) * (1 - BEAVER) * (1 - BED) * (1 - BEE) *
    #           (1 - BEETLE) * (1 - BICYCLE) * (1 - BOTTLE) * (1 - BOWL) * (1 - BOY) * (1 - BRIDGE) * (1 - BUS) *
    #           (1 - BUTTERFLY) * (1 - CAMEL) * (1 - CAN) * (1 - CASTLE) * (1 - CATERPILLAR) * (1 - CATTLE) * (1 - CHAIR) *
    #           (1 - CHIMPANZEE) * (1 - CLOCK) * (1 - CLOUD) * (1 - COCKROACH) * (1 - COUCH) * (1 - CRAB) *
    #           (1 - CROCODILE) * (1 - CUP) * (1 - DINOSAUR) * (1 - DOLPHIN) * (1 - ELEPHANT) * (1 - FLATFISH) *
    #           (1 - FOREST) * (1 - FOX) * (1 - GIRL) * (1 - HAMSTER) * (1 - HOUSE) * (1 - KANGAROO) * (1 - KEYBOARD) *
    #           (1 - LAMP) * (1 - LAWN_MOWER) * (1 - LEOPARD) * (1 - LION) * (1 - LIZARD) * (1 - LOBSTER) * (1 - MAN) *
    #           (1 - MAPLE_TREE) * (1 - MOTORCYCLE) * (1 - MOUNTAIN) * (1 - MOUSE) * (1 - MUSHROOM) * (1 - OAK_TREE) *
    #           (1 - ORANGE) * (1 - ORCHID) * (1 - OTTER) * (1 - PALM_TREE) * (1 - PEAR) * (1 - PICKUP_TRUCK) *
    #           (1 - PINE_TREE) * (1 - PLAIN) * (1 - PLATE) * (1 - POPPY) * (1 - PORCUPINE) * (1 - POSSUM) * (1 - RABBIT) *
    #           (1 - RACCOON) * (1 - RAY) * (1 - ROAD) * (1 - ROCKET) * (1 - ROSE) * (1 - SEA) * (1 - SEAL) * (1 - SHARK) *
    #           (1 - SHREW) * (1 - SKUNK) * (1 - SKYSCRAPER) * (1 - SNAIL) * (1 - SNAKE) * (1 - SPIDER) * (1 - SQUIRREL) *
    #           (1 - STREETCAR) * (1 - SUNFLOWER) * (1 - SWEET_PEPPER) * (1 - TABLE) * (1 - TANK) * (1 - TELEPHONE) *
    #           (1 - TELEVISION) * (1 - TIGER) * (1 - TRACTOR) * (1 - TRAIN) * (1 - TROUT) * (1 - TULIP) * (1 - TURTLE) *
    #           (1 - WARDROBE) * (1 - WHALE) * (1 - WILLOW_TREE) * (1 - WOLF) * (1 - WOMAN) * (1 - WORM)),
    #
    #     # OR ON THE SUPER CLASSES
    #     mu*((1 - AQUATIC_MAMMALS) * (1 - FISH) * (1 - FLOWERS) * (1 - FOOD_CONTAINERS) * (1 - FRUIT_AND_VEGETABLES) *
    #         (1 - HOUSEHOLD_ELECTRICAL_DEVICES) * (1 - HOUSEHOLD_FURNITURE) * (1 - INSECTS) * (1 - LARGE_CARNIVORES) *
    #         (1 - LARGE_MAN_MADE_OUTDOOR_THINGS) * (1 - LARGE_NATURAL_OUTDOOR_SCENES) *
    #         (1 - LARGE_OMNIVORES_AND_HERBIVORES) * (1 - MEDIUM_MAMMALS) * (1 - NON_INSECT_INVERTEBRATES) * (1 - PEOPLE) *
    #         (1 - REPTILES) * (1 - SMALL_MAMMALS) * (1 - TREES) * (1 - VEHICLES_1) * (1 - VEHICLES_2))
    # ])
    # if not train:
    # XOR MAIN CLASSES

    loss_fol_product_tnorm.extend([
        mu/2*(APPLE * (1 - (1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(AQUARIUM_FISH * (1 - (1 - APPLE)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(BABY * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(BEAR * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(BEAVER * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(BED * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(BEE * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(BEETLE * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(BICYCLE * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(BOTTLE * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(BOWL * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(BOY * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(BRIDGE * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(BUS * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(BUTTERFLY * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(CAMEL * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(CAN * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(CASTLE * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(CATERPILLAR * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(CATTLE * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(CHAIR * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(CHIMPANZEE * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(CLOCK * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(CLOUD * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(COCKROACH * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(COUCH * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(CRAB * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(CROCODILE * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(CUP * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(DINOSAUR * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(DOLPHIN * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(ELEPHANT * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(FLATFISH * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(FOREST * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(FOX * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(GIRL * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(HAMSTER * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(HOUSE * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(KANGAROO * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(KEYBOARD * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(LAMP * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(LAWN_MOWER * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(LEOPARD * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(LION * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(LIZARD * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(LOBSTER * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(MAN * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(MAPLE_TREE * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(MOTORCYCLE * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(MOUNTAIN * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(MOUSE * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(MUSHROOM * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(OAK_TREE * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(ORANGE * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(ORCHID * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(OTTER * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(PALM_TREE * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(PEAR * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(PICKUP_TRUCK * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(PINE_TREE * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(PLAIN * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(PLATE * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(POPPY * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(PORCUPINE * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(POSSUM * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(RABBIT * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(RACCOON * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(RAY * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(ROAD * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(ROCKET * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(ROSE * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(SEA * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(SEAL * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(SHARK * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(SHREW * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(SKUNK * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(SKYSCRAPER * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(SNAIL * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(SNAKE * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(SPIDER * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(SQUIRREL * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(STREETCAR * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(SUNFLOWER * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(SWEET_PEPPER * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(TABLE * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(TANK * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(TELEPHONE * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(TELEVISION * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(TIGER * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(TRACTOR * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(TRAIN * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(TROUT * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(TULIP * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(TURTLE * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(WARDROBE * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(WHALE * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(WILLOW_TREE * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WOLF)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(WOLF * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOMAN)*(1 - WORM))),
        mu/2*(WOMAN * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WORM))),
        mu/2*(WORM * (1 - (1 - APPLE)*(1 - AQUARIUM_FISH)*(1 - BABY)*(1 - BEAR)*(1 - BEAVER)*(1 - BED)*(1 - BEE)*(1 - BEETLE)*(1 - BICYCLE)*(1 - BOTTLE)*(1 - BOWL)*(1 - BOY)*(1 - BRIDGE)*(1 - BUS)*(1 - BUTTERFLY)*(1 - CAMEL)*(1 - CAN)*(1 - CASTLE)*(1 - CATERPILLAR)*(1 - CATTLE)*(1 - CHAIR)*(1 - CHIMPANZEE)*(1 - CLOCK)*(1 - CLOUD)*(1 - COCKROACH)*(1 - COUCH)*(1 - CRAB)*(1 - CROCODILE)*(1 - CUP)*(1 - DINOSAUR)*(1 - DOLPHIN)*(1 - ELEPHANT)*(1 - FLATFISH)*(1 - FOREST)*(1 - FOX)*(1 - GIRL)*(1 - HAMSTER)*(1 - HOUSE)*(1 - KANGAROO)*(1 - KEYBOARD)*(1 - LAMP)*(1 - LAWN_MOWER)*(1 - LEOPARD)*(1 - LION)*(1 - LIZARD)*(1 - LOBSTER)*(1 - MAN)*(1 - MAPLE_TREE)*(1 - MOTORCYCLE)*(1 - MOUNTAIN)*(1 - MOUSE)*(1 - MUSHROOM)*(1 - OAK_TREE)*(1 - ORANGE)*(1 - ORCHID)*(1 - OTTER)*(1 - PALM_TREE)*(1 - PEAR)*(1 - PICKUP_TRUCK)*(1 - PINE_TREE)*(1 - PLAIN)*(1 - PLATE)*(1 - POPPY)*(1 - PORCUPINE)*(1 - POSSUM)*(1 - RABBIT)*(1 - RACCOON)*(1 - RAY)*(1 - ROAD)*(1 - ROCKET)*(1 - ROSE)*(1 - SEA)*(1 - SEAL)*(1 - SHARK)*(1 - SHREW)*(1 - SKUNK)*(1 - SKYSCRAPER)*(1 - SNAIL)*(1 - SNAKE)*(1 - SPIDER)*(1 - SQUIRREL)*(1 - STREETCAR)*(1 - SUNFLOWER)*(1 - SWEET_PEPPER)*(1 - TABLE)*(1 - TANK)*(1 - TELEPHONE)*(1 - TELEVISION)*(1 - TIGER)*(1 - TRACTOR)*(1 - TRAIN)*(1 - TROUT)*(1 - TULIP)*(1 - TURTLE)*(1 - WARDROBE)*(1 - WHALE)*(1 - WILLOW_TREE)*(1 - WOLF)*(1 - WOMAN))),


        # XOR SUPER CLASSES
        mu/2*(AQUATIC_MAMMALS * (1 - (1 - FISH)*(1 - FLOWERS)*(1 - FOOD_CONTAINERS)*(1 - FRUIT_AND_VEGETABLES)*(1 - HOUSEHOLD_ELECTRICAL_DEVICES)*(1 - HOUSEHOLD_FURNITURE)*(1 - INSECTS)*(1 - LARGE_CARNIVORES)*(1 - LARGE_MAN_MADE_OUTDOOR_THINGS)*(1 - LARGE_NATURAL_OUTDOOR_SCENES)*(1 - LARGE_OMNIVORES_AND_HERBIVORES)*(1 - MEDIUM_MAMMALS)*(1 - NON_INSECT_INVERTEBRATES)*(1 - PEOPLE)*(1 - REPTILES)*(1 - SMALL_MAMMALS)*(1 - TREES)*(1 - VEHICLES_1)*(1 - VEHICLES_2))),
        mu/2*(FISH * (1 - (1 - AQUATIC_MAMMALS)*(1 - FLOWERS)*(1 - FOOD_CONTAINERS)*(1 - FRUIT_AND_VEGETABLES)*(1 - HOUSEHOLD_ELECTRICAL_DEVICES)*(1 - HOUSEHOLD_FURNITURE)*(1 - INSECTS)*(1 - LARGE_CARNIVORES)*(1 - LARGE_MAN_MADE_OUTDOOR_THINGS)*(1 - LARGE_NATURAL_OUTDOOR_SCENES)*(1 - LARGE_OMNIVORES_AND_HERBIVORES)*(1 - MEDIUM_MAMMALS)*(1 - NON_INSECT_INVERTEBRATES)*(1 - PEOPLE)*(1 - REPTILES)*(1 - SMALL_MAMMALS)*(1 - TREES)*(1 - VEHICLES_1)*(1 - VEHICLES_2))),
        mu/2*(FLOWERS * (1 - (1 - AQUATIC_MAMMALS)*(1 - FISH)*(1 - FOOD_CONTAINERS)*(1 - FRUIT_AND_VEGETABLES)*(1 - HOUSEHOLD_ELECTRICAL_DEVICES)*(1 - HOUSEHOLD_FURNITURE)*(1 - INSECTS)*(1 - LARGE_CARNIVORES)*(1 - LARGE_MAN_MADE_OUTDOOR_THINGS)*(1 - LARGE_NATURAL_OUTDOOR_SCENES)*(1 - LARGE_OMNIVORES_AND_HERBIVORES)*(1 - MEDIUM_MAMMALS)*(1 - NON_INSECT_INVERTEBRATES)*(1 - PEOPLE)*(1 - REPTILES)*(1 - SMALL_MAMMALS)*(1 - TREES)*(1 - VEHICLES_1)*(1 - VEHICLES_2))),
        mu/2*(FOOD_CONTAINERS * (1 - (1 - AQUATIC_MAMMALS)*(1 - FISH)*(1 - FLOWERS)*(1 - FRUIT_AND_VEGETABLES)*(1 - HOUSEHOLD_ELECTRICAL_DEVICES)*(1 - HOUSEHOLD_FURNITURE)*(1 - INSECTS)*(1 - LARGE_CARNIVORES)*(1 - LARGE_MAN_MADE_OUTDOOR_THINGS)*(1 - LARGE_NATURAL_OUTDOOR_SCENES)*(1 - LARGE_OMNIVORES_AND_HERBIVORES)*(1 - MEDIUM_MAMMALS)*(1 - NON_INSECT_INVERTEBRATES)*(1 - PEOPLE)*(1 - REPTILES)*(1 - SMALL_MAMMALS)*(1 - TREES)*(1 - VEHICLES_1)*(1 - VEHICLES_2))),
        mu/2*(FRUIT_AND_VEGETABLES * (1 - (1 - AQUATIC_MAMMALS)*(1 - FISH)*(1 - FLOWERS)*(1 - FOOD_CONTAINERS)*(1 - HOUSEHOLD_ELECTRICAL_DEVICES)*(1 - HOUSEHOLD_FURNITURE)*(1 - INSECTS)*(1 - LARGE_CARNIVORES)*(1 - LARGE_MAN_MADE_OUTDOOR_THINGS)*(1 - LARGE_NATURAL_OUTDOOR_SCENES)*(1 - LARGE_OMNIVORES_AND_HERBIVORES)*(1 - MEDIUM_MAMMALS)*(1 - NON_INSECT_INVERTEBRATES)*(1 - PEOPLE)*(1 - REPTILES)*(1 - SMALL_MAMMALS)*(1 - TREES)*(1 - VEHICLES_1)*(1 - VEHICLES_2))),
        mu/2*(HOUSEHOLD_ELECTRICAL_DEVICES * (1 - (1 - AQUATIC_MAMMALS)*(1 - FISH)*(1 - FLOWERS)*(1 - FOOD_CONTAINERS)*(1 - FRUIT_AND_VEGETABLES)*(1 - HOUSEHOLD_FURNITURE)*(1 - INSECTS)*(1 - LARGE_CARNIVORES)*(1 - LARGE_MAN_MADE_OUTDOOR_THINGS)*(1 - LARGE_NATURAL_OUTDOOR_SCENES)*(1 - LARGE_OMNIVORES_AND_HERBIVORES)*(1 - MEDIUM_MAMMALS)*(1 - NON_INSECT_INVERTEBRATES)*(1 - PEOPLE)*(1 - REPTILES)*(1 - SMALL_MAMMALS)*(1 - TREES)*(1 - VEHICLES_1)*(1 - VEHICLES_2))),
        mu/2*(HOUSEHOLD_FURNITURE * (1 - (1 - AQUATIC_MAMMALS)*(1 - FISH)*(1 - FLOWERS)*(1 - FOOD_CONTAINERS)*(1 - FRUIT_AND_VEGETABLES)*(1 - HOUSEHOLD_ELECTRICAL_DEVICES)*(1 - INSECTS)*(1 - LARGE_CARNIVORES)*(1 - LARGE_MAN_MADE_OUTDOOR_THINGS)*(1 - LARGE_NATURAL_OUTDOOR_SCENES)*(1 - LARGE_OMNIVORES_AND_HERBIVORES)*(1 - MEDIUM_MAMMALS)*(1 - NON_INSECT_INVERTEBRATES)*(1 - PEOPLE)*(1 - REPTILES)*(1 - SMALL_MAMMALS)*(1 - TREES)*(1 - VEHICLES_1)*(1 - VEHICLES_2))),
        mu/2*(INSECTS * (1 - (1 - AQUATIC_MAMMALS)*(1 - FISH)*(1 - FLOWERS)*(1 - FOOD_CONTAINERS)*(1 - FRUIT_AND_VEGETABLES)*(1 - HOUSEHOLD_ELECTRICAL_DEVICES)*(1 - HOUSEHOLD_FURNITURE)*(1 - LARGE_CARNIVORES)*(1 - LARGE_MAN_MADE_OUTDOOR_THINGS)*(1 - LARGE_NATURAL_OUTDOOR_SCENES)*(1 - LARGE_OMNIVORES_AND_HERBIVORES)*(1 - MEDIUM_MAMMALS)*(1 - NON_INSECT_INVERTEBRATES)*(1 - PEOPLE)*(1 - REPTILES)*(1 - SMALL_MAMMALS)*(1 - TREES)*(1 - VEHICLES_1)*(1 - VEHICLES_2))),
        mu/2*(LARGE_CARNIVORES * (1 - (1 - AQUATIC_MAMMALS)*(1 - FISH)*(1 - FLOWERS)*(1 - FOOD_CONTAINERS)*(1 - FRUIT_AND_VEGETABLES)*(1 - HOUSEHOLD_ELECTRICAL_DEVICES)*(1 - HOUSEHOLD_FURNITURE)*(1 - INSECTS)*(1 - LARGE_MAN_MADE_OUTDOOR_THINGS)*(1 - LARGE_NATURAL_OUTDOOR_SCENES)*(1 - LARGE_OMNIVORES_AND_HERBIVORES)*(1 - MEDIUM_MAMMALS)*(1 - NON_INSECT_INVERTEBRATES)*(1 - PEOPLE)*(1 - REPTILES)*(1 - SMALL_MAMMALS)*(1 - TREES)*(1 - VEHICLES_1)*(1 - VEHICLES_2))),
        mu/2*(LARGE_MAN_MADE_OUTDOOR_THINGS * (1 - (1 - AQUATIC_MAMMALS)*(1 - FISH)*(1 - FLOWERS)*(1 - FOOD_CONTAINERS)*(1 - FRUIT_AND_VEGETABLES)*(1 - HOUSEHOLD_ELECTRICAL_DEVICES)*(1 - HOUSEHOLD_FURNITURE)*(1 - INSECTS)*(1 - LARGE_CARNIVORES)*(1 - LARGE_NATURAL_OUTDOOR_SCENES)*(1 - LARGE_OMNIVORES_AND_HERBIVORES)*(1 - MEDIUM_MAMMALS)*(1 - NON_INSECT_INVERTEBRATES)*(1 - PEOPLE)*(1 - REPTILES)*(1 - SMALL_MAMMALS)*(1 - TREES)*(1 - VEHICLES_1)*(1 - VEHICLES_2))),
        mu/2*(LARGE_NATURAL_OUTDOOR_SCENES * (1 - (1 - AQUATIC_MAMMALS)*(1 - FISH)*(1 - FLOWERS)*(1 - FOOD_CONTAINERS)*(1 - FRUIT_AND_VEGETABLES)*(1 - HOUSEHOLD_ELECTRICAL_DEVICES)*(1 - HOUSEHOLD_FURNITURE)*(1 - INSECTS)*(1 - LARGE_CARNIVORES)*(1 - LARGE_MAN_MADE_OUTDOOR_THINGS)*(1 - LARGE_OMNIVORES_AND_HERBIVORES)*(1 - MEDIUM_MAMMALS)*(1 - NON_INSECT_INVERTEBRATES)*(1 - PEOPLE)*(1 - REPTILES)*(1 - SMALL_MAMMALS)*(1 - TREES)*(1 - VEHICLES_1)*(1 - VEHICLES_2))),
        mu/2*(LARGE_OMNIVORES_AND_HERBIVORES * (1 - (1 - AQUATIC_MAMMALS)*(1 - FISH)*(1 - FLOWERS)*(1 - FOOD_CONTAINERS)*(1 - FRUIT_AND_VEGETABLES)*(1 - HOUSEHOLD_ELECTRICAL_DEVICES)*(1 - HOUSEHOLD_FURNITURE)*(1 - INSECTS)*(1 - LARGE_CARNIVORES)*(1 - LARGE_MAN_MADE_OUTDOOR_THINGS)*(1 - LARGE_NATURAL_OUTDOOR_SCENES)*(1 - MEDIUM_MAMMALS)*(1 - NON_INSECT_INVERTEBRATES)*(1 - PEOPLE)*(1 - REPTILES)*(1 - SMALL_MAMMALS)*(1 - TREES)*(1 - VEHICLES_1)*(1 - VEHICLES_2))),
        mu/2*(MEDIUM_MAMMALS * (1 - (1 - AQUATIC_MAMMALS)*(1 - FISH)*(1 - FLOWERS)*(1 - FOOD_CONTAINERS)*(1 - FRUIT_AND_VEGETABLES)*(1 - HOUSEHOLD_ELECTRICAL_DEVICES)*(1 - HOUSEHOLD_FURNITURE)*(1 - INSECTS)*(1 - LARGE_CARNIVORES)*(1 - LARGE_MAN_MADE_OUTDOOR_THINGS)*(1 - LARGE_NATURAL_OUTDOOR_SCENES)*(1 - LARGE_OMNIVORES_AND_HERBIVORES)*(1 - NON_INSECT_INVERTEBRATES)*(1 - PEOPLE)*(1 - REPTILES)*(1 - SMALL_MAMMALS)*(1 - TREES)*(1 - VEHICLES_1)*(1 - VEHICLES_2))),
        mu/2*(NON_INSECT_INVERTEBRATES * (1 - (1 - AQUATIC_MAMMALS)*(1 - FISH)*(1 - FLOWERS)*(1 - FOOD_CONTAINERS)*(1 - FRUIT_AND_VEGETABLES)*(1 - HOUSEHOLD_ELECTRICAL_DEVICES)*(1 - HOUSEHOLD_FURNITURE)*(1 - INSECTS)*(1 - LARGE_CARNIVORES)*(1 - LARGE_MAN_MADE_OUTDOOR_THINGS)*(1 - LARGE_NATURAL_OUTDOOR_SCENES)*(1 - LARGE_OMNIVORES_AND_HERBIVORES)*(1 - MEDIUM_MAMMALS)*(1 - PEOPLE)*(1 - REPTILES)*(1 - SMALL_MAMMALS)*(1 - TREES)*(1 - VEHICLES_1)*(1 - VEHICLES_2))),
        mu/2*(PEOPLE * (1 - (1 - AQUATIC_MAMMALS)*(1 - FISH)*(1 - FLOWERS)*(1 - FOOD_CONTAINERS)*(1 - FRUIT_AND_VEGETABLES)*(1 - HOUSEHOLD_ELECTRICAL_DEVICES)*(1 - HOUSEHOLD_FURNITURE)*(1 - INSECTS)*(1 - LARGE_CARNIVORES)*(1 - LARGE_MAN_MADE_OUTDOOR_THINGS)*(1 - LARGE_NATURAL_OUTDOOR_SCENES)*(1 - LARGE_OMNIVORES_AND_HERBIVORES)*(1 - MEDIUM_MAMMALS)*(1 - NON_INSECT_INVERTEBRATES)*(1 - REPTILES)*(1 - SMALL_MAMMALS)*(1 - TREES)*(1 - VEHICLES_1)*(1 - VEHICLES_2))),
        mu/2*(REPTILES * (1 - (1 - AQUATIC_MAMMALS)*(1 - FISH)*(1 - FLOWERS)*(1 - FOOD_CONTAINERS)*(1 - FRUIT_AND_VEGETABLES)*(1 - HOUSEHOLD_ELECTRICAL_DEVICES)*(1 - HOUSEHOLD_FURNITURE)*(1 - INSECTS)*(1 - LARGE_CARNIVORES)*(1 - LARGE_MAN_MADE_OUTDOOR_THINGS)*(1 - LARGE_NATURAL_OUTDOOR_SCENES)*(1 - LARGE_OMNIVORES_AND_HERBIVORES)*(1 - MEDIUM_MAMMALS)*(1 - NON_INSECT_INVERTEBRATES)*(1 - PEOPLE)*(1 - SMALL_MAMMALS)*(1 - TREES)*(1 - VEHICLES_1)*(1 - VEHICLES_2))),
        mu/2*(SMALL_MAMMALS * (1 - (1 - AQUATIC_MAMMALS)*(1 - FISH)*(1 - FLOWERS)*(1 - FOOD_CONTAINERS)*(1 - FRUIT_AND_VEGETABLES)*(1 - HOUSEHOLD_ELECTRICAL_DEVICES)*(1 - HOUSEHOLD_FURNITURE)*(1 - INSECTS)*(1 - LARGE_CARNIVORES)*(1 - LARGE_MAN_MADE_OUTDOOR_THINGS)*(1 - LARGE_NATURAL_OUTDOOR_SCENES)*(1 - LARGE_OMNIVORES_AND_HERBIVORES)*(1 - MEDIUM_MAMMALS)*(1 - NON_INSECT_INVERTEBRATES)*(1 - PEOPLE)*(1 - REPTILES)*(1 - TREES)*(1 - VEHICLES_1)*(1 - VEHICLES_2))),
        mu/2*(TREES * (1 - (1 - AQUATIC_MAMMALS)*(1 - FISH)*(1 - FLOWERS)*(1 - FOOD_CONTAINERS)*(1 - FRUIT_AND_VEGETABLES)*(1 - HOUSEHOLD_ELECTRICAL_DEVICES)*(1 - HOUSEHOLD_FURNITURE)*(1 - INSECTS)*(1 - LARGE_CARNIVORES)*(1 - LARGE_MAN_MADE_OUTDOOR_THINGS)*(1 - LARGE_NATURAL_OUTDOOR_SCENES)*(1 - LARGE_OMNIVORES_AND_HERBIVORES)*(1 - MEDIUM_MAMMALS)*(1 - NON_INSECT_INVERTEBRATES)*(1 - PEOPLE)*(1 - REPTILES)*(1 - SMALL_MAMMALS)*(1 - VEHICLES_1)*(1 - VEHICLES_2))),
        mu/2*(VEHICLES_1 * (1 - (1 - AQUATIC_MAMMALS)*(1 - FISH)*(1 - FLOWERS)*(1 - FOOD_CONTAINERS)*(1 - FRUIT_AND_VEGETABLES)*(1 - HOUSEHOLD_ELECTRICAL_DEVICES)*(1 - HOUSEHOLD_FURNITURE)*(1 - INSECTS)*(1 - LARGE_CARNIVORES)*(1 - LARGE_MAN_MADE_OUTDOOR_THINGS)*(1 - LARGE_NATURAL_OUTDOOR_SCENES)*(1 - LARGE_OMNIVORES_AND_HERBIVORES)*(1 - MEDIUM_MAMMALS)*(1 - NON_INSECT_INVERTEBRATES)*(1 - PEOPLE)*(1 - REPTILES)*(1 - SMALL_MAMMALS)*(1 - TREES)*(1 - VEHICLES_2))),
        mu/2*(VEHICLES_2 * (1 - (1 - AQUATIC_MAMMALS)*(1 - FISH)*(1 - FLOWERS)*(1 - FOOD_CONTAINERS)*(1 - FRUIT_AND_VEGETABLES)*(1 - HOUSEHOLD_ELECTRICAL_DEVICES)*(1 - HOUSEHOLD_FURNITURE)*(1 - INSECTS)*(1 - LARGE_CARNIVORES)*(1 - LARGE_MAN_MADE_OUTDOOR_THINGS)*(1 - LARGE_NATURAL_OUTDOOR_SCENES)*(1 - LARGE_OMNIVORES_AND_HERBIVORES)*(1 - MEDIUM_MAMMALS)*(1 - NON_INSECT_INVERTEBRATES)*(1 - PEOPLE)*(1 - REPTILES)*(1 - SMALL_MAMMALS)*(1 - TREES)*(1 - VEHICLES_1)))
    ])

    losses = torch.stack(loss_fol_product_tnorm, dim=0)

    if scale:
        if (scale == "a" or scale == "both") and a:
            # scale the first group of rules for the number of predictions made
            # (they may become noisy)
            num_preds = (output > 0.5).sum(dim=1)
            scaling = torch.ones(output.shape[0]) / (num_preds + 1)  # to avoid numerical problem
            scaled_losses = losses[:44] * scaling
            losses[:44] = scaled_losses
        if (scale == "c" or scale == "both") and c:
            # scale by a factor 10 the penultimate rule (which is the most important)
            losses[-2] = losses[-2] * mu

    if sum:
        losses = torch.sum(losses, dim=1)

    if max:
        loss_sum = torch.squeeze(torch.max(losses, dim=0)[0])
    else:
        loss_sum = torch.squeeze(torch.sum(losses, dim=0))

        threshold = .5 if targets else 50.
        if (loss_sum > threshold).any():
            indexes = torch.nonzero(loss_sum > threshold)
            for index in indexes:
                index = index.squeeze()
                strange_prediction = output[index]
                print(f"Very high constraint loss {loss_sum[index]} for index {index}")
                class_preds = strange_prediction > 0.5
                if names is not None:
                    if not isinstance(names, np.ndarray):
                        names = np.asarray(names)
                    name_strange_pred = names[class_preds]
                    print(f"Class predicted: {name_strange_pred}")
                else:
                    print(f"Class idx predicted: {torch.where(class_preds)[0]}")
                # violated_rules = torch.argsort(losses[:, index], descending=True)[:5]
                violated_rules = torch.where(losses[:, index] > 0.5)
                print(f"Most violated rules {violated_rules}")

    assert loss_sum.min() >= 0.0, f"Error in calculating PascalPart constraints, " \
                                  f"got negative loss {loss_sum.min()}"

    if return_arg_max:
        arg_max = torch.argmax(losses, dim=0)
        return loss_sum, arg_max
    return loss_sum
